/***********************************************************************************************************************
* DISCLAIMER
* This software is supplied by Renesas Electronics Corporation and is only 
* intended for use with Renesas products. No other uses are authorized. This 
* software is owned by Renesas Electronics Corporation and is protected under 
* all applicable laws, including copyright laws.
* THIS SOFTWARE IS PROVIDED "AS IS" AND RENESAS MAKES NO WARRANTIES REGARDING 
* THIS SOFTWARE, WHETHER EXPRESS, IMPLIED OR STATUTORY, INCLUDING BUT NOT 
* LIMITED TO WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE 
* AND NON-INFRINGEMENT.  ALL SUCH WARRANTIES ARE EXPRESSLY DISCLAIMED.
* TO THE MAXIMUM EXTENT PERMITTED NOT PROHIBITED BY LAW, NEITHER RENESAS 
* ELECTRONICS CORPORATION NOR ANY OF ITS AFFILIATED COMPANIES SHALL BE LIABLE 
* FOR ANY DIRECT, INDIRECT, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES FOR 
* ANY REASON RELATED TO THIS SOFTWARE, EVEN IF RENESAS OR ITS AFFILIATES HAVE 
* BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.
* Renesas reserves the right, without notice, to make changes to this software 
* and to discontinue the availability of this software.  By using this software, 
* you agree to the additional terms and conditions found by accessing the 
* following link:
* http://www.renesas.com/disclaimer
*
* Copyright (C) 2010, 2011 Renesas Electronics Corporation. All rights reserved.
***********************************************************************************************************************/

/***********************************************************************************************************************
* File Name    : r_cg_intc_user.c
* Version      : CodeGenerator for RL78/G13 V1.03.00 [15 Sep 2011]
* Device(s)    : R5F100LJ
* Tool-Chain   : CA78K0R
* Description  : This file implements device driver for INTC module.
* Creation Date: 8/8/2012
***********************************************************************************************************************/

/***********************************************************************************************************************
Pragma directive
***********************************************************************************************************************/
#pragma interrupt INTP1 r_intc1_interrupt
#pragma interrupt INTP2 r_intc2_interrupt
/* Start user code for pragma. Do not edit comment generated here */
/* End user code. Do not edit comment generated here */

/***********************************************************************************************************************
Includes
***********************************************************************************************************************/
#include "r_cg_macrodriver.h"
#include "r_cg_intc.h"
/* Start user code for include. Do not edit comment generated here */
#include "r_cg_serial.h"
#include "r_cg_timer.h"
/* End user code. Do not edit comment generated here */
#include "r_cg_userdefine.h"

/***********************************************************************************************************************
Global variables and functions
***********************************************************************************************************************/
/* Start user code for global. Do not edit comment generated here */
uint32_t iMTemp = 0;
uint8_t iTemp = 0;
/* End user code. Do not edit comment generated here */

/***********************************************************************************************************************
* Function Name: r_intc1_interrupt
* Description  : This function is INTP1 interrupt service routine.
* Arguments    : None
* Return Value : None
***********************************************************************************************************************/
__interrupt static void r_intc1_interrupt(void)
{
    /* Start user code. Do not edit comment generated here */
	//global update, black
	ED_STANDBYB_HIGH;	//Config ED_STANDBYB pin high
	ED_CLKIN_LOW;		//Config ED_CLKIN pin low
	ED_OUTPUT_LOW;		//Config pin1 of eink low	
	ED_CLKIN_HIGH;		//Config ED_CLKIN pin high

	ED_CLKIN_LOW;		//Config ED_CLKIN pin low
	ED_OUTPUT_HIGH;		//Config pin2 of eink high			
	ED_CLKIN_HIGH;		//Config ED_CLKIN pin high
			
	for(iTemp=3; iTemp<=34; iTemp++)
	{
		ED_CLKIN_LOW;	//Config ED_CLKIN pin low
		ED_OUTPUT_HIGH;	
		ED_CLKIN_HIGH;	//Config ED_CLKIN pin hig				
	}
	ED_CLKIN_LOW;	//Config ED_CLKIN pin low
	ED_OUTPUT_LOW;	
	ED_CLKIN_HIGH;	//Config ED_CLKIN pin hig				
	for (iTemp=36; iTemp<=64; iTemp++)
	{
		ED_CLKIN_LOW;	//Config ED_CLKIN pin low
		ED_OUTPUT_HIGH;	
		ED_CLKIN_HIGH;	//Config ED_CLKIN pin hig
	}
	ED_CS_HIGH;	//Config ED_CS pin high			
	ED_LATCH_HIGH;	//Config ED_LATCH pin high
	NOP();
	NOP();
	ED_LATCH_LOW;	//Config ED_LATCH pin low
	ED_CS_LOW;	//Config ED_CS pin low
	ED_BLANK_LOW;	//Config ED_BLANK pin low
	iMTemp=0;
	for(;iMTemp<200;iMTemp++)	//delay to control eink drive time
	{
		NOP();
	} 
	ED_BLANK_HIGH;	//Config ED_BLANK pin high
	ED_CLKIN_LOW;	//Config ED_CLKIN pin low

	//global update, white
	ED_CLKIN_LOW;	//Config ED_CLKIN pin low
	ED_OUTPUT_HIGH;	//Config pin1 of eink high	
	ED_CLKIN_HIGH;	//Config ED_CLKIN pin high
	for (iTemp=2; iTemp<=64; iTemp++)
	{
		ED_CLKIN_LOW;	//Config ED_CLKIN pin low
		ED_OUTPUT_LOW;	//Config all the other 63 pins output of DA8521 low			
		ED_CLKIN_HIGH;	//Config ED_CLKIN pin high
	}	
	ED_CS_HIGH;	//Config ED_CS pin high			
	ED_LATCH_HIGH;	//Config ED_LATCH pin high
	NOP();
	NOP();
	ED_LATCH_LOW;	//Config ED_LATCH pin low	
	ED_CS_LOW;	//Config ED_CS pin low
	ED_BLANK_LOW;	//Config ED_BLANK pin low	
	iMTemp=0;
	for(;iMTemp<200;iMTemp++)	//delay to control eink drive time	
	{
		NOP();
	} 
	ED_BLANK_HIGH;	//Config ED_BLANK pin high
	ED_CLKIN_LOW;	//Config ED_CLKIN pin low

	//turn on all icons
	ED_CLKIN_LOW;	//Config ED_CLKIN pin low
	ED_OUTPUT_LOW;	//Config pin1 of eink low		
	ED_CLKIN_HIGH;	//Config ED_CLKIN pin high

	ED_CLKIN_LOW;	//Config ED_CLKIN pin low
	ED_OUTPUT_LOW;	//Config pin2 of eink low
	ED_CLKIN_HIGH;	//Config ED_CLKIN pin high
	for(iTemp=3; iTemp<=64; iTemp++)
	{
		ED_CLKIN_LOW;	//Config ED_CLKIN pin low
		ED_OUTPUT_HIGH;	
		ED_CLKIN_HIGH;	//Config ED_CLKIN pin high
	}	
	ED_CS_HIGH;	//Config ED_CS pin high				
	ED_LATCH_HIGH;	//Config ED_LATCH pin high
	NOP();
	NOP();
	ED_LATCH_LOW;	//Config ED_LATCH pin low
	ED_CS_LOW;	//Config ED_CS pin low	
	ED_BLANK_LOW;	//Config ED_BLANK pin low
	iMTemp=0;
	for(;iMTemp<200;iMTemp++)	//delay to control eink drive time
	{
		NOP();
	}  
	ED_BLANK_HIGH;	//Config ED_BLANK pin high
	ED_CLKIN_LOW;	//Config ED_CLKIN pin low
	ED_STANDBYB_LOW;//Config ED_STANDBYB pin low
    /* End user code. Do not edit comment generated here */
}

/***********************************************************************************************************************
* Function Name: r_intc2_interrupt
* Description  : This function is INTP2 interrupt service routine.
* Arguments    : None
* Return Value : None
***********************************************************************************************************************/
__interrupt static void r_intc2_interrupt(void)
{
    /* Start user code. Do not edit comment generated here */
	//global update, black
	ED_STANDBYB_HIGH;	//Config ED_STANDBYB pin high
	ED_CLKIN_LOW;		//Config ED_CLKIN pin low
	ED_OUTPUT_LOW;		//Config pin1 of eink low	
	ED_CLKIN_HIGH;		//Config ED_CLKIN pin high

	ED_CLKIN_LOW;		//Config ED_CLKIN pin low
	ED_OUTPUT_HIGH;		//Config pin2 of eink high			
	ED_CLKIN_HIGH;		//Config ED_CLKIN pin high
			
	for(iTemp=3; iTemp<=34; iTemp++)
	{
		ED_CLKIN_LOW;	//Config ED_CLKIN pin low
		ED_OUTPUT_LOW;	
		ED_CLKIN_HIGH;	//Config ED_CLKIN pin hig				
	}
	ED_CLKIN_LOW;		//Config ED_CLKIN pin low
	ED_OUTPUT_LOW;	
	ED_CLKIN_HIGH;		//Config ED_CLKIN pin hig				
	for (iTemp=36; iTemp<=64; iTemp++)
	{
		ED_CLKIN_LOW;	//Config ED_CLKIN pin low
		ED_OUTPUT_LOW;	
		ED_CLKIN_HIGH;	//Config ED_CLKIN pin hig
	}
	ED_CS_HIGH;		//Config ED_CS pin high			
	ED_LATCH_HIGH;		//Config ED_LATCH pin high
	NOP();
	NOP();
	ED_LATCH_LOW;		//Config ED_LATCH pin low
	ED_CS_LOW;		//Config ED_CS pin low
	ED_BLANK_LOW;		//Config ED_BLANK pin low
	iMTemp=0;
	for(;iMTemp<200;iMTemp++)	//delay to control eink drive time	
	{
		NOP();
	} 
	ED_BLANK_HIGH;		//Config ED_BLANK pin high
	ED_CLKIN_LOW;		//Config ED_CLKIN pin low

	//global update, white
	ED_CLKIN_LOW;		//Config ED_CLKIN pin low
	ED_OUTPUT_HIGH;		//Config pin1 of eink high	
	ED_CLKIN_HIGH;		//Config ED_CLKIN pin high
	for (iTemp=2; iTemp<=64; iTemp++)
	{
		ED_CLKIN_LOW;	//Config ED_CLKIN pin low
		ED_OUTPUT_LOW;	//Config all the other 63 pins output of DA8521 low			
		ED_CLKIN_HIGH;	//Config ED_CLKIN pin high
	}	
	ED_CS_HIGH;		//Config ED_CS pin high			
	ED_LATCH_HIGH;		//Config ED_LATCH pin high
	NOP();
	NOP();
	ED_LATCH_LOW;		//Config ED_LATCH pin low	
	ED_CS_LOW;		//Config ED_CS pin low
	ED_BLANK_LOW;		//Config ED_BLANK pin low	
	iMTemp=0;
	for(;iMTemp<200;iMTemp++)	//delay to control eink drive time
	{
		NOP();
	} 
	ED_BLANK_HIGH;	//Config ED_BLANK pin high
	ED_CLKIN_LOW;	//Config ED_CLKIN pin low

	//turn off all icons
	ED_CLKIN_LOW;	//Config ED_CLKIN pin low
	ED_OUTPUT_LOW;	//Config pin1 of eink low
	ED_CLKIN_HIGH;	//Config ED_CLKIN pin high

	ED_CLKIN_LOW;	//Config ED_CLKIN pin low
	ED_OUTPUT_LOW;	//Config pin2 of eink low
	ED_CLKIN_HIGH;	//Config ED_CLKIN pin high
	for(iTemp=3; iTemp<=34; iTemp++)
	{
		ED_CLKIN_LOW;	//Config ED_CLKIN pin low
		ED_OUTPUT_LOW;	
		ED_CLKIN_HIGH;	//Config ED_CLKIN pin hig				
	}
	ED_CLKIN_LOW;	//Config ED_CLKIN pin low
	ED_OUTPUT_HIGH;	
	ED_CLKIN_HIGH;	//Config ED_CLKIN pin hig				
	for (iTemp=36; iTemp<=64; iTemp++)
	{
		ED_CLKIN_LOW;	//Config ED_CLKIN pin low
		ED_OUTPUT_LOW;	
		ED_CLKIN_HIGH;	//Config ED_CLKIN pin hig
	}	
	ED_CS_HIGH;	//Config ED_CS pin high				
	ED_LATCH_HIGH;	//Config ED_LATCH pin high
	NOP();
	NOP();
	ED_LATCH_LOW;	//Config ED_LATCH pin low
	ED_CS_LOW;	//Config ED_CS pin low	
	ED_BLANK_LOW;	//Config ED_BLANK pin low
	iMTemp=0;
	for(;iMTemp<200;iMTemp++)	//delay around 360ms	
	{
		NOP();
	} 
	ED_BLANK_HIGH;	//Config ED_BLANK pin high
	ED_CLKIN_LOW;	//Config ED_CLKIN pin low
	ED_STANDBYB_LOW;//Config ED_STANDBYB pin low
    /* End user code. Do not edit comment generated here */
}

/* Start user code for adding. Do not edit comment generated here */
/* End user code. Do not edit comment generated here */
