/***********************************************************************************************************************
* DISCLAIMER
* This software is supplied by Renesas Electronics Corporation and is only 
* intended for use with Renesas products. No other uses are authorized. This 
* software is owned by Renesas Electronics Corporation and is protected under 
* all applicable laws, including copyright laws.
* THIS SOFTWARE IS PROVIDED "AS IS" AND RENESAS MAKES NO WARRANTIES REGARDING 
* THIS SOFTWARE, WHETHER EXPRESS, IMPLIED OR STATUTORY, INCLUDING BUT NOT 
* LIMITED TO WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE 
* AND NON-INFRINGEMENT.  ALL SUCH WARRANTIES ARE EXPRESSLY DISCLAIMED.
* TO THE MAXIMUM EXTENT PERMITTED NOT PROHIBITED BY LAW, NEITHER RENESAS 
* ELECTRONICS CORPORATION NOR ANY OF ITS AFFILIATED COMPANIES SHALL BE LIABLE 
* FOR ANY DIRECT, INDIRECT, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES FOR 
* ANY REASON RELATED TO THIS SOFTWARE, EVEN IF RENESAS OR ITS AFFILIATES HAVE 
* BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.
* Renesas reserves the right, without notice, to make changes to this software 
* and to discontinue the availability of this software.  By using this software, 
* you agree to the additional terms and conditions found by accessing the 
* following link:
* http://www.renesas.com/disclaimer
*
* Copyright (C) 2010, 2011 Renesas Electronics Corporation. All rights reserved.
***********************************************************************************************************************/

/***********************************************************************************************************************
* File Name    : r_cg_userdefine.h
* Version      : CodeGenerator for RL78/G13 V1.03.00 [15 Sep 2011]
* Device(s)    : R5F100LJ
* Tool-Chain   : CA78K0R
* Description  : This file includes user definition.
* Creation Date: 8/8/2012
***********************************************************************************************************************/

#ifndef _USER_DEF_H
#define _USER_DEF_H

/***********************************************************************************************************************
User definitions
***********************************************************************************************************************/

/* Start user code for function. Do not edit comment generated here */
#define XL362_DEVID_AD			0x00
#define XL362_DEVID_MST			0x01
#define XL362_PARTID			0x02
#define XL362_REVID			0x03
#define XL362_XDATA			0x08
#define XL362_YDATA			0x09
#define XL362_ZDATA			0x0A
#define XL362_STATUS			0x0B
#define XL362_FIFO_ENTRIES_L		0x0C
#define XL362_FIFO_ENTRIES_H		0x0D
#define XL362_XDATA_L			0x0E
#define XL362_XDATA_H			0x0F
#define XL362_YDATA_L			0x10
#define XL362_YDATA_H			0x11
#define XL362_ZDATA_L			0x12
#define XL362_ZDATA_H			0x13
#define XL362_TEMP_L			0x14
#define XL362_TEMP_H			0x15
#define XL362_SOFT_RESET		0x1F
#define XL362_THRESH_ACT_L		0x20
#define XL362_THRESH_ACT_H		0x21
#define XL362_TIME_ACT			0x22
#define XL362_THRESH_INACT_L		0x23
#define XL362_THRESH_INACT_H		0x24
#define XL362_TIME_INACT_L		0x25
#define XL362_TIME_INACT_H		0x26
#define XL362_ACT_INACT_CTL		0x27
#define XL362_FIFO_CONTROL		0x28
#define XL362_FIFO_SAMPLES		0x29
#define XL362_INTMAP1			0x2A
#define XL362_INTMAP2			0x2B
#define XL362_FILTER_CTL		0x2C
#define XL362_POWER_CTL			0x2D
#define XL362_SELF_TEST			0x2E

#define XL362_CS_HIGH {P0.1 = 1;}	//Config XL362_CS high
#define XL362_CS_LOW {P0.1 = 0;}	//Config XL362_CS low
#define SD_CS_HIGH {P14.6 = 1;}		//Config SD_CS high
#define SD_CS_LOW {P14.6 = 0;}		//Config SD_CS low
#define ED_STANDBYB_HIGH {P3.1 = 1;}	//Config ED_STANDBYB pin high
#define ED_STANDBYB_LOW {P3.1 = 0;}	//Config ED_STANDBYB pin low
#define ED_BLANK_HIGH {P3.0 = 1;}	//Config ED_BLANK pin high
#define ED_BLANK_LOW {P3.0 = 0;}	//Config ED_BLANK pin low
#define ED_CS_HIGH {P0.5 = 1;}		//Config ED_CS pin high
#define ED_CS_LOW {P0.5 = 0;}		//Config ED_CS pin low
#define ED_LATCH_HIGH {P0.6 = 1;}	//Config ED_LATCH pin high
#define ED_LATCH_LOW {P0.6 = 0;}	//Config ED_LATCH pin low
#define ED_CLKIN_HIGH {P7.0 = 1;}	//Config ED_CLKIN pin high
#define ED_CLKIN_LOW {P7.0 = 0;}	//Config ED_CLKIN pin low
#define ED_OUTPUT_HIGH {P7.2 = 1;}	//Config ED_DATAIN pin high	
#define ED_OUTPUT_LOW {P7.2 = 0;}	//Config ED_DATAIN pin low	

#define ERROR 0
#define OK  1
/* End user code. Do not edit comment generated here */
#endif
