/***********************************************************************************************************************
* DISCLAIMER
* This software is supplied by Renesas Electronics Corporation and is only 
* intended for use with Renesas products. No other uses are authorized. This 
* software is owned by Renesas Electronics Corporation and is protected under 
* all applicable laws, including copyright laws.
* THIS SOFTWARE IS PROVIDED "AS IS" AND RENESAS MAKES NO WARRANTIES REGARDING 
* THIS SOFTWARE, WHETHER EXPRESS, IMPLIED OR STATUTORY, INCLUDING BUT NOT 
* LIMITED TO WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE 
* AND NON-INFRINGEMENT.  ALL SUCH WARRANTIES ARE EXPRESSLY DISCLAIMED.
* TO THE MAXIMUM EXTENT PERMITTED NOT PROHIBITED BY LAW, NEITHER RENESAS 
* ELECTRONICS CORPORATION NOR ANY OF ITS AFFILIATED COMPANIES SHALL BE LIABLE 
* FOR ANY DIRECT, INDIRECT, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES FOR 
* ANY REASON RELATED TO THIS SOFTWARE, EVEN IF RENESAS OR ITS AFFILIATES HAVE 
* BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.
* Renesas reserves the right, without notice, to make changes to this software 
* and to discontinue the availability of this software.  By using this software, 
* you agree to the additional terms and conditions found by accessing the 
* following link:
* http://www.renesas.com/disclaimer
*
* Copyright (C) 2010, 2011 Renesas Electronics Corporation. All rights reserved.
***********************************************************************************************************************/

/***********************************************************************************************************************
* File Name    : r_main.c
* Version      : CodeGenerator for RL78/G13 V1.03.00 [15 Sep 2011]
* Device(s)    : R5F100LJ
* Tool-Chain   : CA78K0R
* Description  : This file implements main function.
* Creation Date: 8/8/2012
***********************************************************************************************************************/

/***********************************************************************************************************************
Pragma directive
***********************************************************************************************************************/
/* Start user code for pragma. Do not edit comment generated here */
/* End user code. Do not edit comment generated here */

/***********************************************************************************************************************
Includes
***********************************************************************************************************************/
#include "r_cg_macrodriver.h"
#include "r_cg_cgc.h"
#include "r_cg_intc.h"
#include "r_cg_serial.h"
#include "r_cg_timer.h"
/* Start user code for include. Do not edit comment generated here */
/* End user code. Do not edit comment generated here */
#include "r_cg_userdefine.h"

/***********************************************************************************************************************
Global variables and functions
***********************************************************************************************************************/
/* Start user code for global. Do not edit comment generated here */

uint8_t r_data[36];
uint8_t mTemp = 0;

uint8_t CSI_XL362SendByte(uint8_t txdata)
{
	uint8_t rxdata;
	CSIMK10 = 1;
	CSIIF10 = 0;
	SIO10 = txdata;
	while(!CSIIF10);
	rxdata = SIO10;
	return rxdata;
}
void XL362Write(uint8_t addr, uint8_t data)
{
	XL362_CS_LOW;
	CSI_XL362SendByte(0x0a);
	CSI_XL362SendByte(addr);
	CSI_XL362SendByte(data);
	XL362_CS_HIGH;
}
uint8_t XL362Read(uint8_t addr)
{
	uint8_t rxdata;
	XL362_CS_LOW;
	CSI_XL362SendByte(0x0b);
	CSI_XL362SendByte(addr);
	rxdata = CSI_XL362SendByte(0xff);
	XL362_CS_HIGH;
	return rxdata;
}
void XL362MultiRead(uint8_t addr, uint8_t RxNum)
{
	uint8_t	RXBYTE;
	XL362_CS_LOW;
	CSI_XL362SendByte(0x0b);	//read command
	CSI_XL362SendByte(addr);	//write adress
	for(RXBYTE=0; RXBYTE<RxNum; RXBYTE++)
	{
		r_data[RXBYTE] = CSI_XL362SendByte(0xff);	//Read 8bit data (Send Dummy data 0xff)
	}
	XL362_CS_HIGH;
}

void R_CGC_Set_fCLK(unsigned short mode)
{
	uint32_t i;

	switch (mode)
	{
		/***********************************************
			Internal high-speed oscillator
		***********************************************/
		case	HIOCLK:
			if(HIOSTOP == 1)	/* fIH operating ? */
			{					/* No */
				HIOSTOP = 0;		/* Start fIH operation */

				CSS = 0;			/* Select fIH as fCLK */
				while(CLS != 0){}	/* Wait for fCLK change into fIH */

				XTSTOP = 1;			/* Stop fSUB operation */
			}
			break;

		/***********************************************
			Subsystem clock oscillator
		***********************************************/
		case	SUBXT1CLK:
			
			OSMC = 0x80U;  // 
			//PER0 = 0x80;
			CMC = 0x14;
			////XTSTOP = 0;			/* Start fSUB operation */
			CSC = 0x80;
			/* Software wait 1s or more */
			for( i = 0; i <= 1000; i++ )
			{
				NOP();
			}

			//CSS = 1;			/* Select fSUB as fCLK */
			CKC = 0x40;
			while(CLS != 1){}	/* Wait for fCLK change into fSUB */
			
			
			HIOSTOP = 1;		/* Stop fIH operation */
			
			break;

		/***********************************************
			Another clock = Argument error
		***********************************************/
		default:
			//status = MD_ARGERROR;	/* Return argument error */
			break;
	}
}
/* End user code. Do not edit comment generated here */

/***********************************************************************************************************************
* Function Name: main
* Description  : This function implements main function.
* Arguments    : None
* Return Value : None
***********************************************************************************************************************/
void main(void)
{
    /* Start user code. Do not edit comment generated here */
	R_CGC_Set_fCLK(SUBXT1CLK);
	R_TAU0_Create();

	R_SAU0_Create();
	R_CSI10_Create();
	R_CSI10_Start();	//SPI for ADXL362 communication
	PM0.1 = 0;		//Config ADXL362_CS pin as output

	PM3.1 = 0;		//Config ED_STANDBYB pin as output, ED means the eink driver and it is the DA8521
	PM7.2 = 0;		//Config ED_DATAIN pin as output
	PM7.0 = 0;		//Config ED_CLKIN pin as output
	PM0.6 = 0;		//Config ED_LATCH pin as output
	PM0.5 = 0;		//Config ED_CS pin as output
	PM3.0 = 0;		//Config ED_BLANK pin as output

	ED_STANDBYB_HIGH;	//Config ED_STANDBYB pin high
	ED_BLANK_HIGH;		//Config ED_BLANK pin high
	ED_CS_LOW;		//Config ED_CS pin low
	ED_LATCH_LOW;		//Config ED_LATCH pin low
	ED_CLKIN_LOW;		//Config ED_CLKIN pin low

//global update, black
	ED_CLKIN_LOW;		//Config ED_CLKIN pin low
	ED_OUTPUT_LOW;		//Config pin1 of eink low
	ED_CLKIN_HIGH;		//Config ED_CLKIN pin high

	for (mTemp=2; mTemp<=64; mTemp++)
	{
		ED_CLKIN_LOW;	//Config ED_CLKIN pin low
		ED_OUTPUT_HIGH;	//Config all the other 63 pins output of DA8521 high
		ED_CLKIN_HIGH;	//Config ED_CLKIN pin hig
	}	
	ED_CS_HIGH;		//Config ED_CS pin high			
	ED_LATCH_HIGH;		//Config ED_LATCH pin high
	NOP();
	NOP();
	ED_LATCH_LOW;		//Config ED_LATCH pin low
	ED_CS_LOW;		//Config ED_CS pin low
	ED_BLANK_LOW;		//Config ED_BLANK pin low
	delay280ms();
	ED_BLANK_HIGH;		//Config ED_BLANK pin high
	ED_CLKIN_LOW;		//Config ED_CLKIN pin low

//global update, white
	ED_CLKIN_LOW;		//Config ED_CLKIN pin low
	ED_OUTPUT_HIGH;		//Config pin1 of eink high
	ED_CLKIN_HIGH;		//Config ED_CLKIN pin high

	for (mTemp=2; mTemp<=64; mTemp++)
	{
		ED_CLKIN_LOW;	//Config ED_CLKIN pin low
		ED_OUTPUT_LOW	//Config all the other 63 pins output of DA8521 low			
		ED_CLKIN_HIGH;	//Config ED_CLKIN pin high
	}	
	ED_CS_HIGH;		//Config ED_CS pin high			
	ED_LATCH_HIGH;		//Config ED_LATCH pin high
	NOP();
	NOP();
	ED_LATCH_LOW;		//Config ED_LATCH pin low	
	ED_CS_LOW;		//Config ED_CS pin low
	ED_BLANK_LOW;		//Config ED_BLANK pin low	
	delay280ms();
	ED_BLANK_HIGH;		//Config ED_BLANK pin high
	ED_CLKIN_LOW;		//Config ED_CLKIN pin low

//show "power on" icon
	ED_CLKIN_LOW;		//Config ED_CLKIN pin low
	ED_OUTPUT_LOW;		//Config pin1 of eink low
	ED_CLKIN_HIGH;		//Config ED_CLKIN pin high

	ED_CLKIN_LOW;		//Config ED_CLKIN pin low
	ED_OUTPUT_LOW;		//Config pin2 of eink low		
	ED_CLKIN_HIGH;		//Config ED_CLKIN pin high
	for(mTemp=3; mTemp<=34; mTemp++)
	{
		ED_CLKIN_LOW;	//Config ED_CLKIN pin low
		ED_OUTPUT_LOW;	
		ED_CLKIN_HIGH;	//Config ED_CLKIN pin high
	}	
	ED_CLKIN_LOW;		//Config ED_CLKIN pin low
	ED_OUTPUT_HIGH;		
	ED_CLKIN_HIGH;		//Config ED_CLKIN pin high		
	for (mTemp=36; mTemp<=64; mTemp++)
	{
		ED_CLKIN_LOW;	//Config ED_CLKIN pin low
		ED_OUTPUT_LOW;	
		ED_CLKIN_HIGH;	//Config ED_CLKIN pin high
	}		
	ED_CS_HIGH;		//Config ED_CS pin high				
	ED_LATCH_HIGH;		//Config ED_LATCH pin high
	NOP();
	NOP();
	ED_LATCH_LOW;		//Config ED_LATCH pin low
	ED_CS_LOW;		//Config ED_CS pin low	
	ED_BLANK_LOW;		//Config ED_BLANK pin low
	delay280ms();
	ED_BLANK_HIGH;		//Config ED_BLANK pin high
	ED_CLKIN_LOW;		//Config ED_CLKIN pin low

	ED_STANDBYB_LOW;	//Config ED_STANDBYB pin low

//ADXL362 initialization
	XL362Write(XL362_FILTER_CTL, 0x03);		//2g measurment range, 100Hz ODR
	XL362Write(XL362_THRESH_ACT_H, 0x01);		//act threshold
	XL362Write(XL362_THRESH_ACT_L, 0xF4);		//500mg
	XL362Write(XL362_TIME_ACT, 0x01); 		//activity detection time
	XL362Write(XL362_THRESH_INACT_H, 0x01);		//inact threshold
	XL362Write(XL362_THRESH_INACT_L, 0xF4);		//500mg
	XL362Write(XL362_TIME_INACT_H, 0x01);		//inactivity detection time
	XL362Write(XL362_TIME_INACT_L, 0x2c);		//3 seconds
	XL362Write(XL362_ACT_INACT_CTL, 0x3F);		//loop mode
	XL362Write(XL362_INTMAP1, 0x40);		//awake interrupt on INT1
	XL362Write(XL362_INTMAP2, 0x40);		//awake interrupt on INT2
	XL362Write(XL362_POWER_CTL, 0x06);		//autosleep
	R_INTC_Create();
	R_INTC1_Start();
	R_INTC2_Start();

	while (1U)
    	{;}
	
    /* End user code. Do not edit comment generated here */
}

/* Start user code for adding. Do not edit comment generated here */
/* End user code. Do not edit comment generated here */
